%define major 2
%define minor 6
%define patch 18
%define sublevel 8
%define lustre_version 1.6.2
%define __find_requires %{nil}

Summary: The Linux kernel (the core of the Linux operating system) with Lustre
Name: caos-kernel-lustre
Group: System Environment/Kernel
License: GPLv2
Version: %{major}.%{minor}.%{patch}.%{sublevel}
Release: 1.caos
ExclusiveOS: Linux
Source0: linux-%{version}.tar.bz2
Source1: lustre-%{lustre_version}.tar.gz
Source100: ia32.config
Source101: x86_64.config
Patch100: linux-2.6.18.3-grsecurity_2.1.9_200611100917.patch
PreReq: mkinitrd
AutoReqProv: no
Provides: linux = %{version}-%{release}

%description 
The kernel package contains the Linux kernel (vmlinuz), the core of any
Linux operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

It is called 'caos-kernel' so it doesn't conflict with any other kernel's
that one whishes to install. We are known to be compatiable with RedHat
and standard kernel.org kernel RPMS.

%package source
Summary: The source used to make cAos Linux's Lustre-enabled kernel
Group: System Enviornment/Development

%description source
The source code to make the cAos Linux Lustre kernel

%package userland
Summary: Userland component of Lustre filesystem
Group: System Environment/Kernel
Requires: %{name} = %{version}

%description userland
Tools, utilities, and libraries for using the Lustre filesystem

%prep
%setup -q -n linux-%{version} -a 1
%patch100 -p1

perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = .%{sublevel}-%{release}/" Makefile
rm -f localversion* ||:
%ifarch x86_64
%define buildarch x86_64
cp %SOURCE101 .config
%else
%define buildarch i386
cp %SOURCE100 .config
%endif

# get rid of unwanted files resulting from patch fuzz
find . -name "*.orig" -exec rm -fv {} \;
find . -name "*~" -exec rm -fv {} \;

%build
make ARCH=%{buildarch} oldconfig
make ARCH=%{buildarch} bzImage
make ARCH=%{buildarch} modules

pushd lustre-%{lustre_version}
%configure --with-linux=$RPM_BUILD_DIR/linux-%{version}
%{__make}

%install
mkdir -p $RPM_BUILD_ROOT%{_prefix} $RPM_BUILD_ROOT/boot
%{__make} -C lustre-%{lustre_version} install DESTDIR=$RPM_BUILD_ROOT

install -m 600 System.map $RPM_BUILD_ROOT/boot/System.map-%{version}-%{release}
install -m 644 .config $RPM_BUILD_ROOT/boot/config-%{version}-%{release}

cp arch/%{buildarch}/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-%{version}-%{release}
cp arch/%{buildarch}/boot/zImage.stub $RPM_BUILD_ROOT/boot/zImage.stub-%{version}-%{release} || :

mkdir -p $RPM_BUILD_ROOT/lib/modules/
make ARCH=%{buildarch} INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install

# All of this noise just to create a lightweight yet usable build/ tree
rm -f $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/source
rm -f $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build
%{__mkdir_p} $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build

cp --parents `find . -type f -name "Makefile*" -o -name "Kconfig*"` $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/
cp Module.symvers $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/

rm -rf $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/Documentation
rm -rf $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/scripts
rm -rf $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/include

cp arch/%{buildarch}/kernel/asm-offsets.s $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/arch/%{buildarch}/kernel || :
cp .config $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build
cp -a scripts $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build
cp -a arch/%{buildarch}/scripts $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/arch/%{buildarch} || :
cp -a arch/%{buildarch}/*lds $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/arch/%{buildarch}/ || :

rm -f $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/scripts/*.o
rm -f $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/scripts/*/*.o

mkdir -p $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/include
cd include
cp -a acpi config linux math-emu media net pcmcia rxrpc scsi sound video asm asm-generic $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/include
cp -a `readlink asm` $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/include
%ifarch x86_64
cp -a asm-i386 $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/include
%endif

# Make sure the Makefile and version.h have a matching timestamp so that
# external modules can be built
touch -r $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/Makefile $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/include/linux/version.h
touch -r $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/.config $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/include/linux/autoconf.h
cd .. 
cp -a .version $RPM_BUILD_ROOT/lib/modules/%{version}-%{release}/build/

# OK, done with creation of the build/ tree. whew!

# Lets build the source pacakge
%{__mkdir_p} $RPM_BUILD_ROOT/usr/src/kernels/%{version}-%{release}
make clean
cp -rap . $RPM_BUILD_ROOT/usr/src/kernels/%{version}-%{release}/

# This enables things to get stripped properly by RPM
find $RPM_BUILD_ROOT/lib/modules/ -name "*.ko" -type f  | xargs chmod u+x

%clean
rm -rf $RPM_BUILD_ROOT

%post 
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{version}-%{release}

%preun
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{version}-%{release}

%post userland -p /sbin/ldconfig

%postun userland -p /sbin/ldconfig

%files
%defattr(-,root,root)
%dir /lib/modules/%{version}-%{release}
/boot/*
/lib/modules/%{version}-%{release}/*

%files source
%defattr(-,root,root)
/usr/src/kernels/%{version}-%{release}

%files userland
%defattr(-, root, root)
/sbin/*
%{_bindir}/*
%{_sbindir}/*
%{_includedir}/linux/lustre*
%{_includedir}/lustre
%{_libdir}/lib*
%{_libdir}/lustre
%{_datadir}/lustre
%{_mandir}/man*/*

%changelog
* Fri Jul  7 2006 Greg Kurtzer <gmk@caosity.org>
- Packaged for caos3
